/*     */ package com.gudenau.haxserver;
/*     */ 
/*     */ import java.io.BufferedReader;
/*     */ import java.io.BufferedWriter;
/*     */ import java.io.File;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import java.io.InputStreamReader;
/*     */ import java.io.OutputStream;
/*     */ import java.io.OutputStreamWriter;
/*     */ import java.io.PrintStream;
/*     */ import java.net.Socket;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import javax.swing.JLabel;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class HaxClient
/*     */   implements Runnable
/*     */ {
/*     */   private final Socket socket;
/*     */   private final JLabel errors;
/*     */   private final JLabel sploits;
/*     */   private final JLabel data;
/*  27 */   private static final File dataFile = new File("./data");
/*     */   
/*  29 */   static { dataFile.mkdirs(); }
/*     */   
/*     */   public HaxClient(Socket socket, JLabel sploits, JLabel data, JLabel errors)
/*     */   {
/*  33 */     this.socket = socket;
/*  34 */     this.errors = errors;
/*  35 */     this.data = data;
/*  36 */     this.sploits = sploits;
/*     */   }
/*     */   
/*     */   public void run()
/*     */   {
/*     */     try
/*     */     {
/*  43 */       InputStream in = this.socket.getInputStream();
/*  44 */       OutputStream out = this.socket.getOutputStream();
/*     */       
/*     */ 
/*  47 */       HTTPRequest header = getRequest(in);
/*     */       
/*  49 */       String path = header.getPath();

/*     */       
/*  51 */       SystemVersions version = SystemVersions.getSystemVersion(header.getPropriety("User-Agent"));
/*     */       
System.out.println(path);

/*  53 */       if (version != null) {
				  if (path.equals("/") || path.equals("/index.htm") || path.equals("/index.html")) {
					  serveFile(out, header);
					  this.data.setText(Long.toString(ResourceCounter.instance.dataServed()));
				  }
/*  54 */         else if (path.indexOf('?') != -1) {
/*  55 */           serveHax(version, out, header);
/*  56 */           this.sploits.setText(Long.toString(ResourceCounter.instance.payloadServed()));
/*     */         } else {
	/*  62 */         serveFile(out, header);
	/*  63 */         this.data.setText(Long.toString(ResourceCounter.instance.dataServed()));
	/*     */     }  
/*     */       } else {
/*  62 */         serveFile(out, header);
/*  63 */         this.data.setText(Long.toString(ResourceCounter.instance.dataServed()));
/*     */       }
/*     */       
/*  66 */       in.close();
/*  67 */       out.close();
/*  68 */       this.socket.close();
/*     */     } catch (Exception e) {
/*  70 */       e.printStackTrace();
/*  71 */       this.errors.setText(Long.toString(ResourceCounter.instance.errors()));
/*     */     }
/*     */   }
/*     */   
/*     */   private void serveFile(OutputStream out, HTTPRequest header) throws IOException {
/*  76 */     writeHeader(new BufferedWriter(new OutputStreamWriter(out)), null);
/*     */     
/*     */ 
/*  79 */     System.out.println(header.getPath());
/*  81 */     File file; if (header.getPath().equals("/") || header.getPath().equals("/index.htm") || header.getPath().equals("/index.html")) {
/*  82 */       file = new File(dataFile, "/index.html");
/*     */     } else {
/*  84 */       file = new File(dataFile, header.getPath());
/*     */     }
/*  86 */     System.out.println(file);
/*  87 */     out.write(Util.readFile(file));
/*  88 */     out.flush();
/*     */   }
/*     */   
/*     */   private void serveError(OutputStream out, String Error) throws IOException {
/*  92 */     BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(out));
/*     */     
/*  94 */     writeHeader(writer, "text/html");
/*  95 */     writer.write("<html><head><title>Error</title></head><body><p>There was an error: "+Error+"</p></body></html>");
/*  96 */     writer.flush();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private void writeHeader(BufferedWriter writer, String contentType)
/*     */     throws IOException
/*     */   {
/* 109 */     writer.write("HTTP/1.1 200 OK\r\n");
/* 110 */     if (contentType != null) {
/* 111 */       if (contentType.contains("video")) {
/* 112 */         writer.write("Transfer-Encoding: chunked\r\n");
/*     */       }
/* 114 */       writer.write("Content-Type: ");
/* 115 */       writer.write(contentType);
/* 116 */       writer.write("\r\n");
/*     */     }
/* 118 */     writer.write("\r\n");
/* 119 */     writer.flush();
/*     */   }
/*     */   
/*     */   private void serveHax(SystemVersions systemVersion, OutputStream out, HTTPRequest header) throws Exception {
/* 123 */     BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(out));
/*     */     
/* 125 */     if (-1 == header.getPath().indexOf('?')) {
/* 126 */       serveError(out, "Something weird happened in serveHax");
/* 127 */       return;
/*     */     }
/*     */     
/* 130 */     String payloadName = header.getPath().substring(header.getPath().indexOf('?') + 1);
/* 131 */     System.out.println(payloadName);
/*     */     
/* 133 */     switch (systemVersion) {
/*     */     case EU_2_0_0: 
/*     */     case EU_2_1_0: 
/*     */     case EU_4_0_0: 
/*     */     case EU_5_0_0: 
/*     */     case EU_5_1_0: 
/*     */     case JP_4_0_0: 
/*     */     case JP_5_0_0: 
/*     */     case JP_5_1_0: 
/*     */     case US_5_0_0: 
/*     */     case US_5_1_0: 
/*     */     case US_5_5_0: 
/*     */     case US_5_5_1: 
/*     */     case EU_5_5_0: 
/*     */     case EU_5_5_1: 
/* 143 */       System.out.println(systemVersion.name());
/* 144 */       writeHeader(writer, "video/mp4");
/* 145 */       Stagefright.serveHax(out, systemVersion, header, payloadName + ".bin");
/* 146 */       break;
/*     */     
/*     */     default: 
/* 149 */       serveError(out, "Unsupported version: "+systemVersion.value);
/*     */     }
/*     */   }
/*     */   
/*     */   private HTTPRequest getRequest(InputStream in) throws IOException
/*     */   {
/* 155 */     BufferedReader reader = new BufferedReader(new InputStreamReader(in));
/*     */     
/*     */ 
/* 158 */     String line = reader.readLine();
/*     */     
/*     */ 
/* 161 */     String[] splitLine = line.split(" ");
/* 162 */     String method = splitLine[0].trim();
/* 163 */     String path = splitLine[1].trim();
/* 164 */     String protocol = splitLine[2].trim();
/*     */     
/*     */ 
/* 167 */     List<HTTPPropriety> props = new ArrayList();
/* 168 */     for (line = reader.readLine(); (line != null) && (!line.isEmpty()); line = reader.readLine()) {
/* 169 */       splitLine = line.split(":", 2);
/* 170 */       props.add(new HTTPPropriety(splitLine[0].trim(), splitLine[1].trim()));
/*     */     }
/*     */     
/* 173 */     return new HTTPRequest(method, protocol, path, props);
/*     */   }
/*     */ }


/* Location:              D:\Stuff\WiiUHax\HaxServer.jar!\com\gudenau\haxserver\HaxClient.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       0.7.1
 */